3 # Copyright (C) The Arvados Authors. All rights reserved.
5 # SPDX-License-Identifier: CC-BY-SA-3.0
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
16 # capture the directory that the script is running from
17 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
21 echo >&2 "Usage: ${0} [-h] [-h]"
23 echo >&2 "${0} options:"
24 echo >&2 " -d, --debug Run salt installation in debug mode"
25 echo >&2 " -c <local.params>, --config <local.params> Path to the local.params config file"
26 echo >&2 " -t, --test Test installation running a CWL workflow"
27 echo >&2 " -r, --roles List of Arvados roles to apply to the host, comma separated"
28 echo >&2 " Possible values are:"
30 echo >&2 " controller"
31 echo >&2 " dispatcher"
33 echo >&2 " keepbalance"
36 echo >&2 " monitoring"
41 echo >&2 " workbench2"
42 echo >&2 " Defaults to applying them all"
43 echo >&2 " -h, --help Display this help and exit"
44 echo >&2 " --dump-config <dest_dir> Dumps the pillars and states to a directory"
45 echo >&2 " This parameter does not perform any installation at all. It's"
46 echo >&2 " intended to give you a parsed set of configuration files so"
47 echo >&2 " you can inspect them or use them in you Saltstack infrastructure."
49 echo >&2 " - parses the pillar and states templates,"
50 echo >&2 " - downloads the helper formulas with their desired versions,"
51 echo >&2 " - prepares the 'top.sls' files both for pillars and states"
52 echo >&2 " for the selected role(s)"
53 echo >&2 " - writes the resulting files into <dest_dir>"
54 echo >&2 " -v, --vagrant Run in vagrant and use the /vagrant shared dir"
55 echo >&2 " --development Run in dev mode, using snakeoil certs"
60 # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
61 if ! which getopt > /dev/null; then
62 echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
66 TEMP=$(getopt -o c:dhp:r:tv \
67 --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
71 then echo "Please check the parameters you entered and re-run again"
74 # Note the quotes around `$TEMP': they are essential!
77 while [ ${#} -ge 1 ]; do
89 if [[ ${2} = /* ]]; then
90 DUMP_SALT_CONFIG_DIR=${2}
92 DUMP_SALT_CONFIG_DIR=${PWD}/${2}
95 S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
97 F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
99 P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
101 T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
112 # Verify the role exists
113 if [[ ! "database,balancer,controller,keepstore,websocket,keepweb,workbench2,webshell,keepbalance,keepproxy,shell,workbench,dispatcher,monitoring" == *"$i"* ]]; then
114 echo "The role '${i}' is not a valid role"
118 ROLES="${ROLES:-} ${i}"
146 mkdir -p --mode=0700 /srv/salt/certs
148 if [ -f ${cert_dir}/${cert_name}.crt ]; then
149 install --mode=0600 ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
151 echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
154 if [ -f ${cert_dir}/${cert_name}.key ]; then
155 install --mode=0600 ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
157 echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
162 apply_var_substitutions() {
165 sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
166 s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
167 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
168 s#__CLUSTER__#${CLUSTER}#g;
169 s#__DOMAIN__#${DOMAIN}#g;
170 s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
171 s#__IP_INT__#${IP_INT}#g;
172 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
173 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
174 s#__INITIAL_USER__#${INITIAL_USER}#g;
175 s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
176 s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
177 s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
178 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
179 s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
180 s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
181 s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
182 s#__RELEASE__#${RELEASE}#g;
183 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
184 s#__VERSION__#${VERSION}#g;
185 s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
186 s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
187 s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
188 s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
189 s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
190 s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
191 s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
192 s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
193 s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
194 s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
195 s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
196 s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
197 s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
198 s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
199 s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
200 s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g;
201 s#__SSL_KEY_ENCRYPTED__#${SSL_KEY_ENCRYPTED}#g;
202 s#__SSL_KEY_AWS_REGION__#${SSL_KEY_AWS_REGION}#g;
203 s#__SSL_KEY_AWS_SECRET_NAME__#${SSL_KEY_AWS_SECRET_NAME}#g;
204 s#__CONTROLLER_MAX_WORKERS__#${CONTROLLER_MAX_WORKERS:-}#g;
205 s#__CONTROLLER_MAX_QUEUED_REQUESTS__#${CONTROLLER_MAX_QUEUED_REQUESTS:-128}#g;
206 s#__MONITORING_USERNAME__#${MONITORING_USERNAME}#g;
207 s#__MONITORING_EMAIL__#${MONITORING_EMAIL}#g;
208 s#__MONITORING_PASSWORD__#${MONITORING_PASSWORD}#g;
209 s#__DISPATCHER_SSH_PRIVKEY__#${DISPATCHER_SSH_PRIVKEY//$'\n'/\\n}#g;
210 s#__ENABLE_BALANCER__#${ENABLE_BALANCER}#g;
211 s#__DISABLED_CONTROLLER__#${DISABLED_CONTROLLER}#g;
212 s#__BALANCER_NODENAME__#${ROLE2NODES['balancer']:-}#g;
213 s#__PROMETHEUS_NODENAME__#${ROLE2NODES['monitoring']:-}#g;
214 s#__CONTROLLER_NODES__#${ROLE2NODES['controller']}#g;
215 s#__NODELIST__#${NODELIST}#g;
216 s#__DISPATCHER_INT_IP__#${DISPATCHER_INT_IP}#g;
217 s#__KEEPBALANCE_INT_IP__#${KEEPBALANCE_INT_IP}#g;
218 s#__COMPUTE_AMI__#${COMPUTE_AMI}#g;
219 s#__COMPUTE_SG__#${COMPUTE_SG}#g;
220 s#__COMPUTE_SUBNET__#${COMPUTE_SUBNET}#g;
221 s#__COMPUTE_AWS_REGION__#${COMPUTE_AWS_REGION}#g;
222 s#__COMPUTE_USER__#${COMPUTE_USER}#g;
223 s#__KEEP_AWS_REGION__#${KEEP_AWS_REGION}#g" \
224 "${SRCFILE}" > "${DSTFILE}"
228 CONFIG_FILE="${SCRIPT_DIR}/local.params"
229 CONFIG_DIR="local_config_dir"
232 CONTROLLER_EXT_SSL_PORT=443
235 NGINX_INSTALL_SOURCE="install_from_repo"
240 # Hostnames/IPs used for single-host deploys
245 INITIAL_USER_EMAIL=""
246 INITIAL_USER_PASSWORD=""
248 CONTROLLER_EXT_SSL_PORT=8000
249 KEEP_EXT_SSL_PORT=25101
250 # Both for collections and downloads
251 KEEPWEB_EXT_SSL_PORT=9002
252 WEBSHELL_EXT_SSL_PORT=4202
253 WEBSOCKET_EXT_SSL_PORT=8002
254 WORKBENCH1_EXT_SSL_PORT=443
255 WORKBENCH2_EXT_SSL_PORT=3001
257 SSL_MODE="self-signed"
258 USE_LETSENCRYPT_ROUTE53="no"
259 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/local_config_dir/certs"
261 GRAFANA_DASHBOARDS_DIR="${SCRIPT_DIR}/local_config_dir/dashboards"
263 ## These are ARVADOS-related parameters
264 # For a stable release, change RELEASE "production" and VERSION to the
265 # package version (including the iteration, e.g. X.Y.Z-1) of the
267 # The "local.params.example.*" files already set "RELEASE=production"
268 # to deploy production-ready packages
269 RELEASE="development"
272 # These are arvados-formula-related parameters
273 # An arvados-formula tag. For a stable release, this should be a
274 # branch name (e.g. X.Y-dev) or tag for the release.
275 # ARVADOS_TAG="2.2.0"
278 # We pin the salt version to avoid potential incompatibilities when a new
279 # stable version is released.
282 # Other formula versions we depend on
283 #POSTGRES_TAG="v0.44.0"
284 #POSTGRES_URL="https://github.com/saltstack-formulas/postgres-formula.git"
285 POSTGRES_TAG="0.45.0-bugfix327"
286 POSTGRES_URL="https://github.com/arvados/postgres-formula.git"
290 LETSENCRYPT_TAG="v2.1.0"
291 LOGROTATE_TAG="v0.14.0"
292 PROMETHEUS_TAG="v5.6.5"
296 DUMP_SALT_CONFIG_DIR=""
299 STATES_TOP=${S_DIR}/top.sls
301 F_DIR="/srv/formulas"
304 PILLARS_TOP=${P_DIR}/top.sls
306 T_DIR="/tmp/cluster_tests"
312 declare -A ROLE2NODES
317 if [ ! -d ${CONFIG_DIR} ]; then
318 echo >&2 "You don't seem to have a config directory with pillars and states."
319 echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
320 echo >&2 " * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
321 echo >&2 " * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
325 if grep -rni 'fixme' ${CONFIG_FILE}.secrets ${CONFIG_FILE} ${CONFIG_DIR} ; then
326 echo >&2 "The config files has some parameters that need to be modified."
327 echo >&2 "Please, fix them and re-run the provision script."
331 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
332 echo >&2 "ERROR: <CLUSTER> must be exactly 5 lowercase alphanumeric characters long"
333 echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
337 # Only used in single_host/single_name deploys
338 if [ ! -z "${HOSTNAME_EXT:-}" ] ; then
339 # We need to add some extra control vars to manage a single certificate vs. multiple
340 USE_SINGLE_HOSTNAME="yes"
341 # Make sure that the value configured as IP_INT is a real IP on the system.
342 # If we don't error out early here when there is a mismatch, the formula will
343 # fail with hard to interpret nginx errors later on.
344 ip addr list |grep "${IP_INT}/" >/dev/null
345 if [[ $? -ne 0 ]]; then
346 echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
350 USE_SINGLE_HOSTNAME="no"
351 # We set this variable, anyway, so sed lines do not fail and we don't need to add more
353 HOSTNAME_EXT="${DOMAIN}"
356 if [ "${DUMP_CONFIG}" = "yes" ]; then
357 echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
359 # Install a few dependency packages
360 # First, let's figure out the OS we're working on
361 OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d= |cut -f 2 -d \")
362 echo "Detected distro: ${OS_ID}"
366 echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
367 sed -i 's/SELINUX=enforcing/SELINUX=permissive/g' /etc/sysconfig/selinux
368 setenforce permissive
369 yum install -y curl git jq
372 # Wait 2 minutes for any apt locks to clear
373 # This option is supported from apt 1.9.1 and ignored in older apt versions.
374 # Cf. https://blog.sinjakli.co.uk/2021/10/25/waiting-for-apt-locks-without-the-hacky-bash-scripts/
375 DEBIAN_FRONTEND=noninteractive apt -o DPkg::Lock::Timeout=120 update
376 DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
380 if which salt-call; then
381 echo "Salt already installed"
383 curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
384 sh /tmp/bootstrap_salt.sh -XdfP -x python3 old-stable ${SALT_VERSION}
385 /bin/systemctl stop salt-minion.service
386 /bin/systemctl disable salt-minion.service
389 # Set salt to masterless mode
390 cat > /etc/salt/minion << EOFSM
405 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
407 # Get the formula and dependencies
408 cd ${F_DIR} || exit 1
409 echo "Cloning formulas"
410 test -d docker && ( cd docker && git fetch ) \
411 || git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
412 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" )
415 test -d locale && ( cd locale && git fetch ) \
416 || git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
417 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" )
420 test -d nginx && ( cd nginx && git fetch ) \
421 || git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
422 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" )
425 test -d postgres && ( cd postgres && git fetch ) \
426 || git clone --quiet ${POSTGRES_URL} ${F_DIR}/postgres
427 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" )
430 test -d prometheus && ( cd prometheus && git fetch ) \
431 || git clone --quiet https://github.com/saltstack-formulas/prometheus-formula.git ${F_DIR}/prometheus
432 ( cd prometheus && git checkout --quiet tags/"${PROMETHEUS_TAG}" )
435 test -d grafana && ( cd grafana && git fetch ) \
436 || git clone --quiet https://github.com/saltstack-formulas/grafana-formula.git ${F_DIR}/grafana
437 ( cd grafana && git checkout --quiet "${GRAFANA_TAG}" )
439 echo "...letsencrypt"
440 test -d letsencrypt && ( cd letsencrypt && git fetch ) \
441 || git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
442 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" )
445 test -d logrotate && ( cd logrotate && git fetch ) \
446 || git clone --quiet https://github.com/saltstack-formulas/logrotate-formula.git ${F_DIR}/logrotate
447 ( cd logrotate && git checkout --quiet tags/"${LOGROTATE_TAG}" )
450 test -d arvados || git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
452 # If we want to try a specific branch of the formula
453 if [ "x${BRANCH:-}" != "x" ]; then
454 ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
455 elif [ "x${ARVADOS_TAG:-}" != "x" ]; then
456 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
459 if [ "x${VAGRANT:-}" = "xyes" ]; then
460 EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
461 SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
462 SOURCE_TOFS_DIR="/home/vagrant/${CONFIG_DIR}/tofs"
463 SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
465 EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
466 SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
467 SOURCE_TOFS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/tofs"
468 SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
471 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
473 echo "Writing pillars and states"
475 # Replace variables (cluster, domain, etc) in the pillars, states and tests
476 # to ease deployment for newcomers
477 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
478 echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
481 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
482 apply_var_substitutions "${f}" "${P_DIR}"/$(basename "${f}")
485 if [ ! -d "${SOURCE_TESTS_DIR}" ]; then
486 echo "WARNING: The tests directory was not copied to \"${SOURCE_TESTS_DIR}\"."
487 if [ "x${TEST:-}" = "xyes" ]; then
488 echo "WARNING: Disabling tests for this installation."
493 # Replace cluster and domain name in the test files
494 for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
495 FILTERS="s#__CLUSTER__#${CLUSTER}#g;
496 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
497 s#__DOMAIN__#${DOMAIN}#g;
498 s#__IP_INT__#${IP_INT}#g;
499 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
500 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
501 s#__INITIAL_USER__#${INITIAL_USER}#g;
502 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
503 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
504 if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
505 FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
509 "${f}" > ${T_DIR}/$(basename "${f}")
511 chmod 755 ${T_DIR}/run-test.sh
514 # Replace helper state files that differ from the formula's examples
515 if [ -d "${SOURCE_STATES_DIR}" ]; then
516 mkdir -p "${F_DIR}"/extra/extra
517 rm -f "${F_DIR}"/extra/extra/*
519 for f in $(ls "${SOURCE_STATES_DIR}"/*); do
520 apply_var_substitutions "${f}" "${F_DIR}/extra/extra"/$(basename "${f}")
524 # Now, we build the SALT states/pillars trees
525 # As we need to separate both states and pillars in case we want specific
526 # roles, we iterate on both at the same time
528 # Formula template overrides (TOFS)
529 # See: https://template-formula.readthedocs.io/en/latest/TOFS_pattern.html#template-override
530 if [ -d ${SOURCE_TOFS_DIR} ]; then
531 find ${SOURCE_TOFS_DIR} -mindepth 1 -maxdepth 1 -type d -exec cp -r "{}" ${S_DIR} \;
535 cat > ${STATES_TOP} << EOFTSLS
542 cat > ${PILLARS_TOP} << EOFPSLS
549 # States, extra states
550 if [ -d "${F_DIR}"/extra/extra ]; then
551 SKIP_SNAKE_OIL="snakeoil_certs"
553 if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
554 # In dev mode, we create some snake oil certs that we'll
555 # use as CUSTOM_CERTS, so we don't skip the states file.
556 # Same when using self-signed certificates.
557 SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
559 for f in $(ls "${F_DIR}"/extra/extra/*.sls | egrep -v "${SKIP_SNAKE_OIL}|shell_"); do
560 echo " - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${STATES_TOP}
562 # Use byo or self-signed certificates
563 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
564 mkdir -p "${F_DIR}"/extra/extra/files
568 # If we want specific roles for a node, just add the desired states
569 # and its dependencies
570 if [ -z "${ROLES}" ]; then
572 echo " - nginx.passenger" >> ${STATES_TOP}
573 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
574 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
575 grep -q "aws_credentials" ${STATES_TOP} || echo " - extra.aws_credentials" >> ${STATES_TOP}
577 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
579 mkdir -p --mode=0700 /srv/salt/certs
580 if [ "${SSL_MODE}" = "bring-your-own" ]; then
581 # Copy certs to formula extra/files
582 install --mode=0600 ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
583 # We add the custom_certs state
584 grep -q "custom_certs" ${STATES_TOP} || echo " - extra.custom_certs" >> ${STATES_TOP}
585 if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
586 grep -q "ssl_key_encrypted" ${STATES_TOP} || echo " - extra.ssl_key_encrypted" >> ${STATES_TOP}
589 # In self-signed mode, the certificate files will be created and put in the
590 # destination directory by the snakeoil_certs.sls state file
593 echo " - postgres" >> ${STATES_TOP}
594 echo " - logrotate" >> ${STATES_TOP}
595 echo " - docker.software" >> ${STATES_TOP}
596 echo " - arvados" >> ${STATES_TOP}
597 echo " - extra.shell_sudo_passwordless" >> ${STATES_TOP}
598 echo " - extra.shell_cron_add_login_sync" >> ${STATES_TOP}
599 echo " - extra.passenger_rvm" >> ${STATES_TOP}
602 echo " - docker" >> ${PILLARS_TOP}
603 echo " - nginx_api_configuration" >> ${PILLARS_TOP}
604 echo " - logrotate_api" >> ${PILLARS_TOP}
605 echo " - nginx_controller_configuration" >> ${PILLARS_TOP}
606 echo " - nginx_keepproxy_configuration" >> ${PILLARS_TOP}
607 echo " - nginx_keepweb_configuration" >> ${PILLARS_TOP}
608 echo " - nginx_passenger" >> ${PILLARS_TOP}
609 echo " - nginx_websocket_configuration" >> ${PILLARS_TOP}
610 echo " - nginx_webshell_configuration" >> ${PILLARS_TOP}
611 echo " - nginx_workbench2_configuration" >> ${PILLARS_TOP}
612 echo " - nginx_workbench_configuration" >> ${PILLARS_TOP}
613 echo " - logrotate_wb1" >> ${PILLARS_TOP}
614 echo " - postgresql" >> ${PILLARS_TOP}
616 # We need to tweak the Nginx's pillar depending whether we want plan nginx or nginx+passenger
617 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
618 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
620 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
621 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
622 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
624 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
626 hosts=("controller" "websocket" "workbench" "workbench2" "webshell" "keepproxy")
627 if [ ${USE_SINGLE_HOSTNAME} = "no" ]; then
628 hosts+=("download" "collections")
633 for c in "${hosts[@]}"; do
634 # Are we in a single-host-single-hostname env?
635 if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
636 # Are we in a single-host-single-hostname env?
637 CERT_NAME=${HOSTNAME_EXT}
639 # We are in a multiple-hostnames env
640 CERT_NAME=${c}.${DOMAIN}
643 # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
644 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${CERT_NAME}*/g;
645 s#__CERT_PEM__#/etc/letsencrypt/live/${CERT_NAME}/fullchain.pem#g;
646 s#__CERT_KEY__#/etc/letsencrypt/live/${CERT_NAME}/privkey.pem#g" \
647 ${P_DIR}/nginx_${c}_configuration.sls
650 # Use custom certs (either dev mode or prod)
651 grep -q "extra_custom_certs" ${PILLARS_TOP} || echo " - extra_custom_certs" >> ${PILLARS_TOP}
652 # And add the certs in the custom_certs pillar
653 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
654 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
656 for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
657 # Are we in a single-host-single-hostname env?
658 if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
659 # Are we in a single-host-single-hostname env?
660 CERT_NAME=${HOSTNAME_EXT}
662 # We are in a multiple-hostnames env
666 if [[ "$SSL_MODE" == "bring-your-own" ]]; then
667 copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
670 grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo " - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
672 # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
673 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${CERT_NAME}.pem/g;
674 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
675 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
676 ${P_DIR}/nginx_${c}_configuration.sls
680 # If we add individual roles, make sure we add the repo first
681 echo " - arvados.repo" >> ${STATES_TOP}
682 # We add the extra_custom_certs state
683 grep -q "extra.custom_certs" ${STATES_TOP} || echo " - extra.custom_certs" >> ${STATES_TOP}
684 if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
685 grep -q "ssl_key_encrypted" ${STATES_TOP} || echo " - extra.ssl_key_encrypted" >> ${STATES_TOP}
688 # And we add the basic part for the certs pillar
689 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
690 # And add the certs in the custom_certs pillar
691 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
692 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
693 grep -q "extra_custom_certs" ${PILLARS_TOP} || echo " - extra_custom_certs" >> ${PILLARS_TOP}
696 # Prometheus state on all nodes due to the node exporter below
697 grep -q "\- prometheus$" ${STATES_TOP} || echo " - prometheus" >> ${STATES_TOP}
698 # Prometheus node exporter pillar
699 grep -q "prometheus_node_exporter" ${PILLARS_TOP} || echo " - prometheus_node_exporter" >> ${PILLARS_TOP}
701 for R in ${ROLES}; do
705 grep -q "\- postgres$" ${STATES_TOP} || echo " - postgres" >> ${STATES_TOP}
706 grep -q "extra.prometheus_pg_exporter" ${STATES_TOP} || echo " - extra.prometheus_pg_exporter" >> ${STATES_TOP}
708 grep -q "postgresql" ${PILLARS_TOP} || echo " - postgresql" >> ${PILLARS_TOP}
709 grep -q "prometheus_pg_exporter" ${PILLARS_TOP} || echo " - prometheus_pg_exporter" >> ${PILLARS_TOP}
712 ### Support files ###
713 GRAFANA_DASHBOARDS_DEST_DIR=/srv/salt/dashboards
714 mkdir -p "${GRAFANA_DASHBOARDS_DEST_DIR}"
715 rm -f "${GRAFANA_DASHBOARDS_DEST_DIR}"/*
716 # "ArvadosPromDataSource" is the hardcoded UID for Prometheus' datasource
718 for f in $(ls "${GRAFANA_DASHBOARDS_DIR}"/*.json); do
719 sed 's#${DS_PROMETHEUS}#ArvadosPromDataSource#g' \
720 "${f}" > "${GRAFANA_DASHBOARDS_DEST_DIR}"/$(basename "${f}")
724 grep -q "\- nginx$" ${STATES_TOP} || echo " - nginx" >> ${STATES_TOP}
725 grep -q "extra.nginx_prometheus_configuration" ${STATES_TOP} || echo " - extra.nginx_prometheus_configuration" >> ${STATES_TOP}
727 grep -q "\- grafana$" ${STATES_TOP} || echo " - grafana" >> ${STATES_TOP}
728 grep -q "extra.grafana_datasource" ${STATES_TOP} || echo " - extra.grafana_datasource" >> ${STATES_TOP}
729 grep -q "extra.grafana_dashboards" ${STATES_TOP} || echo " - extra.grafana_dashboards" >> ${STATES_TOP}
730 grep -q "extra.grafana_admin_user" ${STATES_TOP} || echo " - extra.grafana_admin_user" >> ${STATES_TOP}
732 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
733 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
734 if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
735 grep -q "aws_credentials" ${STATES_TOP} || echo " - aws_credentials" >> ${STATES_TOP}
737 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
738 for SVC in grafana prometheus; do
739 copy_custom_cert ${CUSTOM_CERTS_DIR} ${SVC}
743 grep -q "prometheus_server" ${PILLARS_TOP} || echo " - prometheus_server" >> ${PILLARS_TOP}
744 grep -q "grafana" ${PILLARS_TOP} || echo " - grafana" >> ${PILLARS_TOP}
745 for SVC in grafana prometheus; do
746 grep -q "nginx_${SVC}_configuration" ${PILLARS_TOP} || echo " - nginx_${SVC}_configuration" >> ${PILLARS_TOP}
748 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
749 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
750 for SVC in grafana prometheus; do
751 grep -q "letsencrypt_${SVC}_configuration" ${PILLARS_TOP} || echo " - letsencrypt_${SVC}_configuration" >> ${PILLARS_TOP}
752 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${SVC}.${DOMAIN}*/g;
753 s#__CERT_PEM__#/etc/letsencrypt/live/${SVC}.${DOMAIN}/fullchain.pem#g;
754 s#__CERT_KEY__#/etc/letsencrypt/live/${SVC}.${DOMAIN}/privkey.pem#g" \
755 ${P_DIR}/nginx_${SVC}_configuration.sls
757 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
758 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
760 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
761 grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo " - ssl_key_encrypted" >> ${PILLARS_TOP}
762 for SVC in grafana prometheus; do
763 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${SVC}.pem/g;
764 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${SVC}.pem#g;
765 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${SVC}.key#g" \
766 ${P_DIR}/nginx_${SVC}_configuration.sls
767 grep -q ${SVC} ${P_DIR}/extra_custom_certs.sls || echo " - ${SVC}" >> ${P_DIR}/extra_custom_certs.sls
773 grep -q "\- nginx$" ${STATES_TOP} || echo " - nginx" >> ${STATES_TOP}
775 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
776 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
777 if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
778 grep -q "aws_credentials" ${STATES_TOP} || echo " - aws_credentials" >> ${STATES_TOP}
780 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
781 copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
785 grep -q "nginx_${R}_configuration" ${PILLARS_TOP} || echo " - nginx_${R}_configuration" >> ${PILLARS_TOP}
787 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
788 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
790 grep -q "letsencrypt_${R}_configuration" ${PILLARS_TOP} || echo " - letsencrypt_${R}_configuration" >> ${PILLARS_TOP}
791 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${ROLE2NODES['balancer']}*/g;
792 s#__CERT_PEM__#/etc/letsencrypt/live/${ROLE2NODES['balancer']}/fullchain.pem#g;
793 s#__CERT_KEY__#/etc/letsencrypt/live/${ROLE2NODES['balancer']}/privkey.pem#g" \
794 ${P_DIR}/nginx_${R}_configuration.sls
796 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
797 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
799 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
800 grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo " - ssl_key_encrypted" >> ${PILLARS_TOP}
801 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
802 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
803 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
804 ${P_DIR}/nginx_${R}_configuration.sls
805 grep -q "${R}" ${P_DIR}/extra_custom_certs.sls || echo " - ${R}" >> ${P_DIR}/extra_custom_certs.sls
810 grep -q " - logrotate" ${STATES_TOP} || echo " - logrotate" >> ${STATES_TOP}
811 if grep -q " - nginx.*$" ${STATES_TOP}; then
812 sed -i s/"^ - nginx.*$"/" - nginx.passenger"/g ${STATES_TOP}
814 echo " - nginx.passenger" >> ${STATES_TOP}
816 echo " - extra.passenger_rvm" >> ${STATES_TOP}
818 ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
819 ### after it. So we add this here as we are, after all, sharing the host for api and controller
820 if [ "${ENABLE_BALANCER}" == "no" ]; then
821 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
822 if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
823 grep -q "aws_credentials" ${STATES_TOP} || echo " - aws_credentials" >> ${STATES_TOP}
825 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
826 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
827 copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
828 grep -q controller ${P_DIR}/extra_custom_certs.sls || echo " - controller" >> ${P_DIR}/extra_custom_certs.sls
831 grep -q "arvados.api" ${STATES_TOP} || echo " - arvados.api" >> ${STATES_TOP}
832 grep -q "arvados.controller" ${STATES_TOP} || echo " - arvados.controller" >> ${STATES_TOP}
835 grep -q "logrotate_api" ${PILLARS_TOP} || echo " - logrotate_api" >> ${PILLARS_TOP}
836 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
837 grep -q "postgresql" ${PILLARS_TOP} || echo " - postgresql" >> ${PILLARS_TOP}
838 grep -q "nginx_passenger" ${PILLARS_TOP} || echo " - nginx_passenger" >> ${PILLARS_TOP}
839 grep -q "nginx_api_configuration" ${PILLARS_TOP} || echo " - nginx_api_configuration" >> ${PILLARS_TOP}
840 grep -q "nginx_controller_configuration" ${PILLARS_TOP} || echo " - nginx_controller_configuration" >> ${PILLARS_TOP}
842 if [ "${ENABLE_BALANCER}" == "no" ]; then
843 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
844 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
845 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
848 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
849 grep -q "letsencrypt_${R}_configuration" ${PILLARS_TOP} || echo " - letsencrypt_${R}_configuration" >> ${PILLARS_TOP}
850 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${DOMAIN}*/g;
851 s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${DOMAIN}/fullchain.pem#g;
852 s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${DOMAIN}/privkey.pem#g" \
853 ${P_DIR}/nginx_${R}_configuration.sls
855 grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo " - ssl_key_encrypted" >> ${PILLARS_TOP}
856 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
857 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
858 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
859 ${P_DIR}/nginx_${R}_configuration.sls
860 grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo " - ${R}" >> ${P_DIR}/extra_custom_certs.sls
863 # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
864 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
865 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
867 "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
869 if [ "${R}" = "workbench" ]; then
870 grep -q " - logrotate" ${STATES_TOP} || echo " - logrotate" >> ${STATES_TOP}
871 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
872 if grep -q " - nginx$" ${STATES_TOP}; then
873 sed -i s/"^ - nginx.*$"/" - nginx.passenger"/g ${STATES_TOP}
875 echo " - nginx.passenger" >> ${STATES_TOP}
878 grep -q "\- nginx$" ${STATES_TOP} || echo " - nginx" >> ${STATES_TOP}
881 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
882 if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
883 grep -q "aws_credentials" ${STATES_TOP} || echo " - aws_credentials" >> ${STATES_TOP}
885 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
887 # Use custom certs, special case for keepweb
888 if [ ${R} = "keepweb" ]; then
889 if [ "${SSL_MODE}" = "bring-your-own" ]; then
890 copy_custom_cert ${CUSTOM_CERTS_DIR} download
891 copy_custom_cert ${CUSTOM_CERTS_DIR} collections
894 if [ "${SSL_MODE}" = "bring-your-own" ]; then
895 copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
900 # webshell role is just a nginx vhost, so it has no state
901 if [ "${R}" != "webshell" ]; then
902 grep -q "arvados.${R}" ${STATES_TOP} || echo " - arvados.${R}" >> ${STATES_TOP}
906 if [ "${R}" = "workbench" ]; then
907 grep -q "logrotate_wb1" ${PILLARS_TOP} || echo " - logrotate_wb1" >> ${PILLARS_TOP}
909 grep -q "nginx_passenger" ${PILLARS_TOP} || echo " - nginx_passenger" >> ${PILLARS_TOP}
910 grep -q "nginx_${R}_configuration" ${PILLARS_TOP} || echo " - nginx_${R}_configuration" >> ${PILLARS_TOP}
911 # Special case for keepweb
912 if [ ${R} = "keepweb" ]; then
913 grep -q "nginx_download_configuration" ${PILLARS_TOP} || echo " - nginx_download_configuration" >> ${PILLARS_TOP}
914 grep -q "nginx_collections_configuration" ${PILLARS_TOP} || echo " - nginx_collections_configuration" >> ${PILLARS_TOP}
917 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
918 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
919 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
921 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
922 grep -q "letsencrypt_${R}_configuration" ${PILLARS_TOP} || echo " - letsencrypt_${R}_configuration" >> ${PILLARS_TOP}
924 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
925 # Special case for keepweb
926 if [ ${R} = "keepweb" ]; then
927 for kwsub in download collections; do
928 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${DOMAIN}*/g;
929 s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${DOMAIN}/fullchain.pem#g;
930 s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${DOMAIN}/privkey.pem#g" \
931 ${P_DIR}/nginx_${kwsub}_configuration.sls
934 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${DOMAIN}*/g;
935 s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${DOMAIN}/fullchain.pem#g;
936 s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${DOMAIN}/privkey.pem#g" \
937 ${P_DIR}/nginx_${R}_configuration.sls
940 grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo " - ssl_key_encrypted" >> ${PILLARS_TOP}
941 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
942 # Special case for keepweb
943 if [ ${R} = "keepweb" ]; then
944 for kwsub in download collections; do
945 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
946 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
947 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
948 ${P_DIR}/nginx_${kwsub}_configuration.sls
949 grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo " - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
952 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
953 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
954 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
955 ${P_DIR}/nginx_${R}_configuration.sls
956 grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo " - ${R}" >> ${P_DIR}/extra_custom_certs.sls
959 # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
960 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
964 echo " - extra.shell_sudo_passwordless" >> ${STATES_TOP}
965 echo " - extra.shell_cron_add_login_sync" >> ${STATES_TOP}
966 grep -q "docker" ${STATES_TOP} || echo " - docker.software" >> ${STATES_TOP}
967 grep -q "arvados.${R}" ${STATES_TOP} || echo " - arvados.${R}" >> ${STATES_TOP}
969 grep -q "docker" ${PILLARS_TOP} || echo " - docker" >> ${PILLARS_TOP}
971 "dispatcher" | "keepbalance" | "keepstore")
973 grep -q "arvados.${R}" ${STATES_TOP} || echo " - arvados.${R}" >> ${STATES_TOP}
975 # ATM, no specific pillar needed
978 echo "Unknown role ${R}"
985 if [ "${DUMP_CONFIG}" = "yes" ]; then
986 # We won't run the rest of the script because we're just dumping the config
990 # Now run the install
991 salt-call --state-output=mixed --local state.apply -l ${LOG_LEVEL}
993 # Finally, make sure that /etc/hosts is not overwritten on reboot
994 if [ -d /etc/cloud/cloud.cfg.d ]; then
995 # TODO: will this work on CentOS?
996 sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
999 # Leave a copy of the Arvados CA so the user can copy it where it's required
1000 if [ "${SSL_MODE}" = "self-signed" ]; then
1001 echo "Copying the Arvados CA certificate '${DOMAIN}-arvados-snakeoil-ca.crt' to the installer dir, so you can import it"
1002 if [ "x${VAGRANT:-}" = "xyes" ]; then
1003 cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${DOMAIN}-arvados-snakeoil-ca.pem
1005 cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${DOMAIN}-arvados-snakeoil-ca.crt
1009 if [ "x${VAGRANT:-}" = "xyes" ]; then
1010 # If running in a vagrant VM, also add default user to docker group
1011 echo "Adding the vagrant user to the docker group"
1012 usermod -a -G docker vagrant
1015 # Test that the installation finished correctly
1016 if [ "x${TEST:-}" = "xyes" ]; then
1018 # If we use RVM, we need to run this with it, or most ruby commands will fail
1020 if [ -x /usr/local/rvm/bin/rvm-exec ]; then
1021 RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
1023 ${RVM_EXEC} ./run-test.sh